#include <stdio.h>
#include <math.h>
#include <string.h>
#include <malloc.h>
#include "rpp.h"


#define DEBUG 0
#define DEBUG1 1


/* ========== these rectangle funcs have to be colourized ==================== */

Image *extractRectFromImg( Image *i, int x ,int y , int w,  int h ){
  Image *r;
  if( x+w > i->w || y+h > i->h ){
    printf("ERROR: extract too big a rectangle!\n");
    printf("x %d w %d i->w %d y %d h %d i->h %d\n", x,w,i->w,y,h,i->h);
    exit(-1);
  }
  r = (Image *) malloc( sizeof(Image) );
  r->w =w;
  r->h = h;
  r->bpp = i->bpp;
  /*
  if( i->name == NULL ){
    printf("%s: %s: %d: NULL image name.\n",__FILE__,__FUNCTION__, __LINE__);
    exit(-1);
  }
  */
  //r->name = (char *) malloc( (strlen(i->name)+1)*sizeof(char));
  //strcpy(r->name, i->name);
  r->name = NULL;
  r->size = w*h;
  r->data = (unsigned char *)malloc( sizeof(unsigned char) * r->size * r->bpp );
  r->id = i->id;

  switch( r->bpp ){
    case 1:
      reverse_blitRect( r->data, w, h, i->data, i->w, i->h, x, y );
      break;
    case 3:
      reverse_blitRect_c( r->data, w, h, i->data, i->w, i->h, x, y );
      break;
    default:
      printf("%s: unknown bpp %d.\n", __FUNCTION__, r->bpp );
      exit(-1);
  }
  return r;

}

void reverse_blitRect( unsigned char *dest, int dw, int dh, unsigned char *src, int sw, int sh, int x, int y){
  unsigned char *p=dest;
  unsigned char *end=p+dw*dh;
  int ds = sw - dw;
  unsigned char *s = src+y*sw+x -ds; /* -ds for first time */
  while( p < end ){
    if( !((p-dest) % dw) ){
      s += ds;
    }
    *p = *s;
    s++;
    p++;
  }
}

void reverse_blitRect_c( unsigned char *dest, int dw, int dh, unsigned char *src, int sw, int sh, int x, int y){
  unsigned char *p=dest;
  unsigned char *end=p+dw*dh*3;
  int ds = (sw - dw)*3;
  unsigned char *s = src+y*sw*3+x*3 -ds; /* -ds for first time */
  while( p < end ){
    if( !((p-dest) % (dw*3) ) ){
      s += ds;
    }
    *p++ = *s++;
    *p++ = *s++;
    *p++ = *s++;
  }
}

void placeRectinImg( Image *to, Image *from, int x, int y ){
  if( x+from->w > to->w || y+from->h > to->h ){
    printf("ERROR: place too big a rectangle!\n");
    printf("x %d from->w %d to->w %d y %d from->h %d to->h %d\n", x, from->w, to->w, y, from->h, to->h);
    printf("from->name %s\n", from->name);
    exit(-1);
  }
  if( to->bpp != from->bpp ){
    printf("%s: bpp %d != %d.\n", __FUNCTION__, to->bpp, from->bpp );
    exit(-1);
  }
  switch( to->bpp ){
    case 1:
      blitRect( to->data, to->w, to->h, x, y, from->data, from->w, from->h );
      break;
    case 3:
      blitRect_c( to->data, to->w, to->h, x, y, from->data, from->w, from->h );
      break;
    default:
      printf("%s: unknown bpp %d.\n", __FUNCTION__, to->bpp );
      exit(-1);
  }

}

void blitRect( unsigned char *dest, int dw, int dh, int x, int y, unsigned char *src, int sw, int sh ){
  unsigned char *p=src;
  unsigned char *end=p+sw*sh;
  int ds = dw - sw;
  unsigned char *s=dest+y*dw+x -ds; /* -ds for first time */
  
  while( p < end ){
    if( !((p-src) % sw) ){
      s += ds;
    }
    *s++ = *p++;

  }
}


void blitRect_c( unsigned char *dest, int dw, int dh, int x, int y, unsigned char *src, int sw, int sh ){
  unsigned char *p=src;
  unsigned char *end=p+sw*sh*3;
  int ds = (dw - sw)*3;
  unsigned char *s=dest+y*dw*3+x*3 -ds; /* -ds for first time */
  
  while( p < end ){
    if( !((p-src) %(3*sw) ) ){
      s += ds;
    }
    *s++ = *p++;
    *s++ = *p++;
    *s++ = *p++;

  }
}
